Description

Support Anfrage:

kurze Frage zum MacroResolver.

Ich habe folgenden Code:

    cMacroResolver oMacroResolver;

    cString curdir = oMacroResolver.Resolve("$CURDIR$");

    cString datFile = oMacroResolver.Resolve("$HD_PLAYER_FILE$");

Die Zeile mit "CURDIR" wird erfolgreich aufgelöst.

Das DAT-File aus dem HD Player wird als leerer cString zurückgegeben - also konnte das Macro nicht aufgelöst werden.    

Muss man dem HD Player, außer dem DAT File, noch etwas mitgeben?

Lösung:

Siehe auch Lösung aus verlinkten Ticket #2747.

Durch Marc Bartholomäus hinzugefügt:

Eine (lokale) cMacroResolver-Instanz kann nur ein paar wenige statische Macros auflösen (envvars, ...).

Es gibt aber eine adtf-weite Instanz vom MacroResolver. Bei der werden die "dynamischen" Werte registriert.

(Nur) Bei String-Properties werden die Macros übrigens automatisch (mit Hilfe der adtf-weiten Instanz) aufgelöst.

So sollte es gehen:

    tChar resolved[1024];

    memset(resolved, 0, 1024);

    ucom::cObjectPtr<adtf::IMacroResolver> _pMacroResolver;

    if (IS_OK(_runtime->GetObject(NULL, IID_ADTF_MACRO_RESOLVER, (tVoid**)&_pMacroResolver)))

    {

        if (IS_OK(_pMacroResolver->ResolveMacros("$HD_PLAYER_FILE$", resolved, 512)))

        {

            LOG_INFO(cString::Format("Via Object: '%s'", resolved));

        }

    }

Related issues:

Related to Public Support - Support Request #2747: Retrieve name of dat file Closed

History

#1 - 2019-02-14 15:43 - hidden

- Related to Support Request #2747: Retrieve name of dat file added

2024-04-29 1/3

https://support.digitalwerk.net/issues/2747


#2 - 2019-02-14 16:23 - hidden

- Project changed from Public Support to 4

- Status changed from New to Customer Feedback Required

- Topic set to ADTF::FilterSDK

- Customer set to AUDI

Hallo Anian,

sieh Dir bitte hierzu das verlinkte Ticket #2747 an.

Gruß

Matthias

#3 - 2019-02-15 08:21 - hidden

Hallo Matthias,

danke für die ref auf Ricks Ticket.

Dass ich auf Recorder-Events hören kann, kenne ich. Ist in meinem Fall jedoch zu "Overpowered".

Ich möchte einfach nur in der Start-Methode mit dem Macro arbeiten.

Anderes Beispiel.

Erstellt man eine hidden Property und schreibt in diese das gewünschte Macro so wird das Macro korrekt aufgelöst.

Ist ein Workaround, aber nicht schön.

#4 - 2019-02-15 08:37 - hidden

- Status changed from Customer Feedback Required to In Progress

@Flo: Kannst Du Anian weiterhelfen?

#5 - 2019-02-15 10:58 - hidden

Mein Senf dazu:

Eine (lokale) cMacroResolver-Instanz kann nur ein paar wenige statische Macros auflösen (envvars, ...).

Es gibt aber eine adtf-weite Instanz vom MacroResolver. Bei der werden die "dynamischen" Werte registriert.

(Nur) Bei String-Properties werden die Macros übrigens automatisch (mit Hilfe der adtf-weiten Instanz) aufgelöst.

So sollte es gehen:

    tChar resolved[1024];

    memset(resolved, 0, 1024);

    ucom::cObjectPtr<adtf::IMacroResolver> _pMacroResolver;

    if (IS_OK(_runtime->GetObject(NULL, IID_ADTF_MACRO_RESOLVER, (tVoid**)&_pMacroResolver)))

    {

        if (IS_OK(_pMacroResolver->ResolveMacros("$HD_PLAYER_FILE$", resolved, 512)))

        {

            LOG_INFO(cString::Format("Via Object: '%s'", resolved));

        }

    }

#6 - 2019-02-15 11:00 - hidden

- Status changed from In Progress to Customer Feedback Required

#7 - 2019-02-18 14:47 - hidden

Ok, kann dann geschlossen werden.

#8 - 2019-02-18 15:08 - hidden

- Description updated

- Status changed from Customer Feedback Required to To Be Closed

- Resolution set to Solved Issue

#9 - 2019-03-08 13:41 - hidden

- Project changed from 4 to Public Support
https://support.digitalwerk.net/issues/2747


- Subject changed from MacroResolver DAT-File Var to HD_PLAYER_FILE could not be resolved

- Status changed from To Be Closed to Closed

- Private changed from Yes to No
